<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Constructors</title>
</head>
<body>
  <div class="wrap"></div>
  <script>
    // class Planet {
    //   constructor (name) {
    //     this.name = name;
    //     this.population = 10000;
    //   }

    //   getPopulation() {
    //     this.population = Math.floor((Math.random() * (1000 - 1 + 1)) + 1) * 10000; 
    //     console.log(this.population);
    //   }

    //   rotatePlanet() {
    //     let populationMultiplyRate = Math.floor(Math.random() * (10 - 1 + 1)) + 1;
    //     const randomPopulation = function (){
    //       return Math.floor(Math.random() * (10000 - 1000 + 1000)) + 1000;
    //     }

    //     const growPopulation = () => {
    //       let wasBurned = populationMultiplyRate * 250;
    //       console.log(this, `За один цикл прибавилось: ${wasBurned}`);
    //       this.population += wasBurned;
    //     }

    //     const Cataclysm = () => {
    //       let wasDied = populationMultiplyRate * 250;
    //       console.log(this, `За один цикл погибло: ${wasDied}`);
    //       return this.population -= wasDied;
    //     }

    //     let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
    //     if ( (randomNumber % 2) == 0) {
    //       growPopulation();  
    //     } else {
    //       Cataclysm();            
    //     }

    //     console.log(`Now on the planet ${this.name}: ${this.population} people`);
    //   }
    // } 

   
  
    document.addEventListener('DOMContentLoaded', () => {
      

      function Planet (name) {
        this.name = name;
        this.population = getPopulation();

        this.rotatePlanet = function() {
          
          function populationMultiplyRate () {
            return Math.floor(Math.random() * (10 - 1 + 1)) + 1;
          }

          function randomPopulation () {
            return Math.floor((Math.random() * (1000 - 1 + 1)) + 1); 
          }

          const growPopulation = () => {
            let wasBurned = populationMultiplyRate() * 100;
            wasBurned = randomPopulation() + wasBurned;
            this.population += wasBurned;
            console.log(`За один цикл прибавилось: ${wasBurned}`);
          }

          const cataclysm = () => {
            let wasDied = populationMultiplyRate() * 250;
            wasDied = randomPopulation() - wasDied;
            this.population -= wasDied;
            console.log(`За один цикл погибло: ${wasDied}`);
          }

          let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
          if ((randomNumber % 2) == 0) {
            growPopulation();  
          } else {
            cataclysm();            
          }

          console.log(`Now on the planet ${this.name}: ${this.population} people`);
        } 

        function getPopulation() {
          return Math.floor((Math.random() * (1000 - 1 + 1)) + 1) * 1000; 
        }
      }

      mars = new Planet('Mars');
      saturn = new Planet('Saturn');
      mars.rotatePlanet();
      saturn.rotatePlanet();
    });
  /*

    Задание:

    Написать функцию конструктор, которая будет иметь приватные и публичные свойства.
    Публичные методы должны вызывать приватные.

    Рассмотрим на примере планеты:

      - На вход принимаются параметр Имя планеты.

      Создается новый обьект, который имеет публичные методы и свойства:
      - name (передается через конструктор)
      - population ( randomPopulation());
      - rotatePlanet(){
        let randomNumber = Math.floor(Math.random() * (1000 - 1 + 1)) + 1;
        if ( (randomNumber % 2) == 0) {
          growPopulation();
        } else {
          Cataclysm();
        }
      }

      Приватное свойство:
      populationMultiplyRate - случайное число от 1 до 10;

      Приватные методы
      randomPopulation -> Возвращает случайное целое число от 1.000 до 10.000
      growPopulation() {
        функция которая берет приватное свойство populationMultiplyRate
        которое равняется случайному числу от 1 до 10 и умножает его на 100.
        Дальше, число которое вышло добавляет к популяции и выводит в консоль сообщение,
        что за один цикл прибавилось столько населения на планете .
      }
      Cataclysm(){
        Рандомим число от 1 до 10 и умножаем его на 250;
        То число которое получили, отнимаем от популяции.
        В консоль выводим сообщение - от катаклизма погибло Х человек на планете.
      }

  */

  </script>
</body>
</html>
